# Copyright (C) 2009 The Android Open Source Project
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

LOCAL_PATH := $(call my-dir)
STAITC_LIB_PATH := $(LOCAL_PATH)/../../lib/android/armeabi-v7a

include $(CLEAR_VARS)
LOCAL_MODULE :=hpr
LOCAL_SRC_FILES := $(STAITC_LIB_PATH)/libhpr.a
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := usb1.0 
LOCAL_SRC_FILES := $(STAITC_LIB_PATH)/libusb1.0.so
include $(PREBUILT_SHARED_LIBRARY)

#--------------------------------------------------------------------------------------------------------------------
include $(CLEAR_VARS)
LOCAL_MODULE    := uvc
PRIVATE_INCLUDE_PATH:= $(LOCAL_PATH)/../../src

# 递归遍历获取所有目录
INCLUDES += $(shell find $(PRIVATE_INCLUDE_PATH) -type d)
#$(warning "$(INCLUDES)")

#头文件目录
LOCAL_C_INCLUDES := $(LOCAL_PATH)/../../include \
                    $(LOCAL_PATH)/../../include/hpr
					
#$(warning "$(LOCAL_C_INCLUDES)")									 
# 递归遍历目录下的所有的文件
rwildcard = $(wildcard $1$2) $(foreach d,$(wildcard $1*), $(call rwildcard,$d/,$2))

# 获取相应的源文件
APP_ALL_FILES := $(foreach CHILD_PATH,$(PRIVATE_INCLUDE_PATH), $(call rwildcard,$(CHILD_PATH), *.*))
APP_ALL_FILES := $(APP_ALL_FILES:$(LOCAL_PATH)/%=%)

APP_SRC_LIST := $(filter %.cpp, $(APP_ALL_FILES)) $(filter %.c, $(APP_ALL_FILES))
APP_SRC_LIST := $(APP_SRC_LIST:$(LOCAL_PATH)/%=%)
#$(warning "$(APP_SRC_LIST)")
LOCAL_SRC_FILES := $(APP_SRC_LIST)

#--------------------------------------------------------------------------------------------------------------------

LOCAL_STATIC_LIBRARIES := hpr 
LOCAL_SHARED_LIBRARIES := usb1.0 
LOCAL_LDLIBS := -ldl -llog
TARGET_PLATFORM := android-3
include $(BUILD_SHARED_LIBRARY)
#include $(BUILD_STATIC_LIBRARY)


